Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2250700 - Review Request: python-bioread - Utilities to read BIOPAC AcqKnowledge files
Summary: Review Request: python-bioread - Utilities to read BIOPAC AcqKnowledge files
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ankur Sinha (FranciscoD)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2023-11-20 16:17 UTC by Ben Beasley
Modified: 2023-12-01 02:15 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-11-22 00:12:38 UTC
Type: ---
Embargoed:
sanjay.ankur: fedora-review+


Attachments (Terms of Use)

Description Ben Beasley 2023-11-20 16:17:22 UTC
Spec URL: https://music.fedorapeople.org/python-bioread.spec
SRPM URL: https://music.fedorapeople.org/python-bioread-3.0.1-1.fc39.src.rpm

Description:



Fedora Account System Username: music

Koji scratch builds (forced to build on all architectures to verify there are no arch-dependent build failures):

F40: https://koji.fedoraproject.org/koji/taskinfo?taskID=109305454
F39: https://koji.fedoraproject.org/koji/taskinfo?taskID=109305607
F38: https://koji.fedoraproject.org/koji/taskinfo?taskID=109305635

This will be a neuro-sig package. It is a dependency for (one of the extras of) bidscoin, https://pagure.io/neuro-sig/NeuroFedora/issue/500.

Comment 1 Fedora Review Service 2023-11-20 16:28:46 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6670537
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2250700-python-bioread/srpm-builds/06670537/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Ankur Sinha (FranciscoD) 2023-11-21 05:46:20 UTC
Looks good. My only query is about the extras packages---they're all arched and I don't supposed there's a way of making them noarch? It doesn't really matter, just that rpmlint picks up the lack of binaries in them.

$ ls *rpm
python3-bioread-3.0.1-1.fc40.noarch.rpm      python3-bioread+hdf5-3.0.1-1.fc40.x86_64.rpm  python-bioread-3.0.1-1.fc40.src.rpm
python3-bioread+all-3.0.1-1.fc40.x86_64.rpm  python3-bioread+mat-3.0.1-1.fc40.x86_64.rpm


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 9992 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Binary eggs must be removed in %prep
     Note: Cannot find any build in BUILD directory (--prebuilt option?)
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-bioread , python3-bioread+mat , python3-bioread+hdf5 ,
     python3-bioread+all
[x]: Package functions as described.
^
test pass

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-bioread-3.0.1-1.fc40.noarch.rpm
          python3-bioread+mat-3.0.1-1.fc40.x86_64.rpm
          python3-bioread+hdf5-3.0.1-1.fc40.x86_64.rpm
          python3-bioread+all-3.0.1-1.fc40.x86_64.rpm
          python-bioread-3.0.1-1.fc40.src.rpm
=========================================================================== rpmlint session starts ==========================================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpgrrj91lk')]
checks: 31, packages: 5

python3-bioread+all.x86_64: W: no-documentation
python3-bioread+hdf5.x86_64: W: no-documentation
python3-bioread+mat.x86_64: W: no-documentation
python3-bioread+all.x86_64: E: no-binary
python3-bioread+hdf5.x86_64: E: no-binary
python3-bioread+mat.x86_64: E: no-binary
============================================ 5 packages and 0 specfiles checked; 3 errors, 3 warnings, 3 badness; has taken 0.9 s ===========================================




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 4

python3-bioread+mat.x86_64: W: no-documentation
python3-bioread+all.x86_64: W: no-documentation
python3-bioread+hdf5.x86_64: W: no-documentation
python3-bioread+mat.x86_64: E: no-binary
python3-bioread+all.x86_64: E: no-binary
python3-bioread+hdf5.x86_64: E: no-binary
 4 packages and 0 specfiles checked; 3 errors, 3 warnings, 3 badness; has taken 0.1 s 



Source checksums
----------------
https://github.com/uwmadison-chm/bioread/archive/v3.0.1/bioread-3.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : 0613f257317857e5c2e8af4bf9715ea4b1b823fe70e3cff70be93ac785e0a7fb
  CHECKSUM(SHA256) upstream package : 0613f257317857e5c2e8af4bf9715ea4b1b823fe70e3cff70be93ac785e0a7fb


Requires
--------
python3-bioread (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3.12dist(docopt)
    python3.12dist(numpy)

python3-bioread+mat (rpmlib, GLIBC filtered):
    python(abi)
    python3-bioread
    python3.12dist(scipy)

python3-bioread+hdf5 (rpmlib, GLIBC filtered):
    python(abi)
    python3-bioread
    python3.12dist(h5py)

python3-bioread+all (rpmlib, GLIBC filtered):
    python(abi)
    python3-bioread
    python3.12dist(h5py)
    python3.12dist(scipy)



Provides
--------
python3-bioread:
    python-bioread
    python3-bioread
    python3.12-bioread
    python3.12dist(bioread)
    python3dist(bioread)

python3-bioread+mat:
    python-bioread+mat
    python3-bioread+mat
    python3-bioread+mat(x86-64)
    python3.12-bioread+mat
    python3.12dist(bioread[mat])
    python3dist(bioread[mat])

python3-bioread+hdf5:
    python-bioread+hdf5
    python3-bioread+hdf5
    python3-bioread+hdf5(x86-64)
    python3.12-bioread+hdf5
    python3.12dist(bioread[hdf5])
    python3dist(bioread[hdf5])

python3-bioread+all:
    python-bioread+all
    python3-bioread+all
    python3-bioread+all(x86-64)
    python3.12-bioread+all
    python3.12dist(bioread[all])
    python3dist(bioread[all])



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2250700
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: PHP, Haskell, Java, fonts, Ocaml, C/C++, SugarActivity, R, Perl
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 3 Ben Beasley 2023-11-21 13:06:50 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #2)
> Looks good. My only query is about the extras packages---they're all arched
> and I don't supposed there's a way of making them noarch? It doesn't really
> matter, just that rpmlint picks up the lack of binaries in them.

I think that there is no way of doing this for an arched base package other than defining them manually without the assistance of %pyproject_extras_subpackage. I’ve sometimes found that necessary in order to do unusual things like adding upgrade paths for old subpackages, but it doesn’t seem worth it just for making them noarch. This limitation is alluded to from a different perspective in https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_extras_macros:

> Due to technical limitations, the macro never generates requirements on the arched BASE_PACKAGE%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}. It only adds Requires: BASE_PACKAGE = %{?epoch:%{epoch}:}%{version}-%{release}) because a macro cannot reliably detect if the subpackage is arched or not. So far, this has not been a problem in practice.

However, the fact that the base package is arched is copied from another package I used as a template, and it’s probably unnecessary for this package. Certainly, the comment about endian-dependent test failures is not accurate for this package. Try this:

New Spec URL: https://music.fedorapeople.org/20231121/python-bioread.spec
New SRPM URL: https://music.fedorapeople.org/20231121/python-bioread-3.0.1-1.fc39.src.rpm

Comment 4 Fedora Review Service 2023-11-21 13:15:26 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6674477
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2250700-python-bioread/fedora-rawhide-x86_64/06674477-python-bioread/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 5 Ankur Sinha (FranciscoD) 2023-11-21 17:10:44 UTC
> However, the fact that the base package is arched is copied from another package I used as a template, and it’s probably unnecessary for this package. Certainly, the comment about endian-dependent test failures is not accurate for this package. Try this:

> New Spec URL: https://music.fedorapeople.org/20231121/python-bioread.spec
> New SRPM URL: https://music.fedorapeople.org/20231121/python-bioread-3.0.1-1.fc39.src.rpm


Cool, that now also makes rpmlint happy:

Rpmlint
-------
Checking: python3-bioread-3.0.1-1.fc40.noarch.rpm
          python3-bioread+mat-3.0.1-1.fc40.noarch.rpm
          python3-bioread+hdf5-3.0.1-1.fc40.noarch.rpm
          python3-bioread+all-3.0.1-1.fc40.noarch.rpm
          python-bioread-3.0.1-1.fc40.src.rpm
=========================================================================== rpmlint session starts ==========================================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpmrhpt5i6')]
checks: 31, packages: 5

python3-bioread+all.noarch: W: no-documentation
python3-bioread+hdf5.noarch: W: no-documentation
python3-bioread+mat.noarch: W: no-documentation
============================================ 5 packages and 0 specfiles checked; 0 errors, 3 warnings, 0 badness; has taken 0.9 s ===========================================




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 4

python3-bioread+all.noarch: W: no-documentation
python3-bioread+hdf5.noarch: W: no-documentation
python3-bioread+mat.noarch: W: no-documentation
 4 packages and 0 specfiles checked; 0 errors, 3 warnings, 0 badness; has taken 0.1 s 





XXX APPROVED XXX

Comment 6 Ben Beasley 2023-11-21 23:52:14 UTC
Thank you for the review!

Comment 7 Fedora Admin user for bugzilla script actions 2023-11-21 23:58:00 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-bioread

Comment 8 Fedora Update System 2023-11-22 00:10:10 UTC
FEDORA-2023-a07992920d has been submitted as an update to Fedora 40. https://bodhi.fedoraproject.org/updates/FEDORA-2023-a07992920d

Comment 9 Fedora Update System 2023-11-22 00:12:38 UTC
FEDORA-2023-a07992920d has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 10 Fedora Update System 2023-11-22 03:00:06 UTC
FEDORA-2023-29b67f73a3 has been submitted as an update to Fedora 39. https://bodhi.fedoraproject.org/updates/FEDORA-2023-29b67f73a3

Comment 11 Fedora Update System 2023-11-22 17:11:00 UTC
FEDORA-2023-cd0e4b87ad has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-cd0e4b87ad

Comment 12 Fedora Update System 2023-11-22 18:33:50 UTC
FEDORA-EPEL-2023-5315aae2c7 has been submitted as an update to Fedora EPEL 9. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5315aae2c7

Comment 13 Fedora Update System 2023-11-23 01:30:29 UTC
FEDORA-2023-cd0e4b87ad has been pushed to the Fedora 38 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-cd0e4b87ad \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-cd0e4b87ad

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2023-11-23 02:25:09 UTC
FEDORA-2023-29b67f73a3 has been pushed to the Fedora 39 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-29b67f73a3 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-29b67f73a3

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2023-11-23 03:01:57 UTC
FEDORA-EPEL-2023-5315aae2c7 has been pushed to the Fedora EPEL 9 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5315aae2c7

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 16 Fedora Update System 2023-12-01 01:22:45 UTC
FEDORA-2023-29b67f73a3 has been pushed to the Fedora 39 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2023-12-01 01:29:53 UTC
FEDORA-2023-cd0e4b87ad has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 18 Fedora Update System 2023-12-01 02:15:28 UTC
FEDORA-EPEL-2023-5315aae2c7 has been pushed to the Fedora EPEL 9 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.